#include "stm32f2xx.h"
#include "TIM.h"


void TIM2_Init(void)
{
    // ʹܶʱ2ʱ
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);
    
    TIM_TimeBaseInitTypeDef TIM_TimeBaseStructure;
    
    // öʱ
    TIM_TimeBaseStructure.TIM_Prescaler = 8399;  // ԤƵ84MHz/8400=10kHzļƵ
    TIM_TimeBaseStructure.TIM_Period = 10000;   // 趨ԶװؼĴڵֵ10,000Ϊ1s
    TIM_TimeBaseStructure.TIM_ClockDivision = 0;
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;
    TIM_TimeBaseInit(TIM2, &TIM_TimeBaseStructure);

    // ʱ2
    TIM_Cmd(TIM2, ENABLE);
}

void TIM2_Start(void)
{
    // ʱ2ж
    TIM_ITConfig(TIM2, TIM_IT_Update, ENABLE);
    
    // öʱ2ж
    NVIC_InitTypeDef NVIC_InitStructure;
    NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
}

void TIM2_Stop(void)
{
    // رնʱ2ж
    TIM_ITConfig(TIM2, TIM_IT_Update, DISABLE);
}

void TIM2_IRQHandler(void)
{
    if (TIM_GetITStatus(TIM2, TIM_IT_Update) != RESET)
    {
        // ʱж
			
        // жϱ־
        TIM_ClearITPendingBit(TIM2, TIM_IT_Update);
    }
}
